function handles = load_pattern_img(handles, type)

name = {'lipids', 'dirt', 'dust'};
index = [handles.index_lipids, handles.index_dirt, handles.index_dust];
filename = sprintf('%s/%s_%04d.png', name{type}, name{type}, index(type));

g = load(sprintf('%s/%s-g.txt', name{type}, name{type}));

if exist(filename)
    img = double(imread(filename))/255;
        
    img = rgb2gray(img);
    
    a = img>0;
    g = g(index(type)+1)*a;
    
    if type == 1
        handles.img_lipids = img;
        handles.g_lipids = g;
        
        axes(handles.axes_lipids);
        imshow(img);
        set(handles.text_lipids_info, 'String', sprintf('idx %d w %d  h %d', index(type), size(img,2), size(img,1)));
        
    elseif type == 2
        handles.img_dirt = img;
        handles.g_dirt = g;
        
        axes(handles.axes_dirt);
        imshow(img);
        set(handles.text_dirt_info, 'String', sprintf('idx %d w %d  h %d', index(type), size(img,2), size(img,1)));
        
    else
        handles.img_dust = img;
        handles.g_dust = g;
        
        axes(handles.axes_dust);
        imshow(img);
        set(handles.text_dust_info, 'String', sprintf('idx %d w %d  h %d', index(type), size(img,2), size(img,1)));
    end
    
else
    warning(sprintf('File %s does not exist.', filename));
end