function varargout = synthesis(varargin)
% SYNTHESIS M-file for synthesis.fig
%      SYNTHESIS, by itself, creates a new SYNTHESIS or raises the existing
%      singleton*.
%
%      H = SYNTHESIS returns the handle to a new SYNTHESIS or the handle to
%      the existing singleton*.
%
%      SYNTHESIS('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SYNTHESIS.M with the given input arguments.
%
%      SYNTHESIS('Property','Value',...) creates a new SYNTHESIS or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before synthesis_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to synthesis_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help synthesis

% Last Modified by GUIDE v2.5 29-Dec-2006 14:40:35

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @synthesis_OpeningFcn, ...
                   'gui_OutputFcn',  @synthesis_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before synthesis is made visible.
function synthesis_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to synthesis (see VARARGIN)

handles.index_lipids = 0;
handles.index_dirt = 0;
handles.index_dust = 0;

handles = load_pattern_img(handles, 1);
handles = load_pattern_img(handles, 2);
handles = load_pattern_img(handles, 3);

handles.weight_lipids = 1;
handles.weight_dirt = 1;
handles.weight_dust = 1;

handles.new_img_lipids = 0;
handles.new_img_dirt = 0;
handles.new_img_dust = 0;

handles.old_img_lipids = 0;
handles.old_img_dirt = 0;
handles.old_img_dust = 0;

handles.new_g_lipids = 0;
handles.new_g_dirt = 0;
handles.new_g_dust = 0;

handles.old_g_lipids = 0;
handles.old_g_dirt = 0;
handles.old_g_dust = 0;

handles.width = 1024;
handles.height = 1024;

handles.amt_lipids=10;
handles.amt_dirt=3;

handles.range_lipids=1;
handles.range_dirt=1;

handles.tilesize = 64;
handles.overlap = 10;
handles.err = 0.05;

handles.visible_lipids = 1;
handles.visible_dirt = 1;
handles.visible_dust = 1;

handles.visible_tau = 0;
handles.visible_g = 0;

% Choose default command line output for synthesis
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes synthesis wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = synthesis_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on slider movement.
function slider_index_lipids_Callback(hObject, eventdata, handles)
% hObject    handle to slider_index_lipids (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.index_lipids = get(hObject, 'Value');
handles = load_pattern_img(handles, 1);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function slider_index_lipids_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_index_lipids (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_index_dirt_Callback(hObject, eventdata, handles)
% hObject    handle to slider_index_dirt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.index_dirt = get(hObject, 'Value');
handles = load_pattern_img(handles, 2);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function slider_index_dirt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_index_dirt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_index_dust_Callback(hObject, eventdata, handles)
% hObject    handle to slider_index_dust (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.index_dust = get(hObject, 'Value');
handles = load_pattern_img(handles, 3);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function slider_index_dust_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_index_dust (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_amt_lipids_Callback(hObject, eventdata, handles)
% hObject    handle to slider_amt_lipids (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.amt_lipids = get(hObject, 'Value');
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function slider_amt_lipids_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_amt_lipids (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_amt_dirt_Callback(hObject, eventdata, handles)
% hObject    handle to slider_amt_dirt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.amt_dirt = get(hObject, 'Value');
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function slider_amt_dirt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_amt_dirt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function edit_width_Callback(hObject, eventdata, handles)
% hObject    handle to edit_width (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_width as text
%        str2double(get(hObject,'String')) returns contents of edit_width as a double

handles.width = str2double(get(hObject, 'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_width_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_width (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_height_Callback(hObject, eventdata, handles)
% hObject    handle to edit_height (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_height as text
%        str2double(get(hObject,'String')) returns contents of edit_height as a double

handles.height = str2double(get(hObject, 'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_height_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_height (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_tilesize_Callback(hObject, eventdata, handles)
% hObject    handle to edit_tilesize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_tilesize as text
%        str2double(get(hObject,'String')) returns contents of edit_tilesize as a double

handles.tilesize = str2double(get(hObject, 'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_tilesize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_tilesize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_overlap_Callback(hObject, eventdata, handles)
% hObject    handle to edit_overlap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_overlap as text
%        str2double(get(hObject,'String')) returns contents of edit_overlap as a double
handles.overlap = str2double(get(hObject, 'String'));
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit_overlap_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_overlap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_err_Callback(hObject, eventdata, handles)
% hObject    handle to edit_err (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_err as text
%        str2double(get(hObject,'String')) returns contents of edit_err as a double

handles.err = str2double(get(hObject, 'String'));
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_err_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_err (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
    set(hObject,'String',sprintf('%f',.05));
end



% --- Executes on button press in button_save.
function button_save_Callback(hObject, eventdata, handles)
% hObject    handle to button_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[file,path] = uiputfile('result','Save file name');

imwrite(handles.new_img_tau, [path,file,'-tau.png']);
imwrite(handles.new_img_g, [path,file,'-g.png']);


% --- Executes on button press in button_run_lipids.
function button_run_lipids_Callback(hObject, eventdata, handles)
% hObject    handle to button_run_lipids (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

width = handles.width;
height = handles.height;
handles.old_img_lipids = handles.new_img_lipids;
handles.old_g_lipids = handles.new_g_lipids;

a = zeros(size(handles.img_lipids, 1), size(handles.img_lipids, 2), 2);
a(:,:,1) = handles.img_lipids;
a(:,:,2) = handles.g_lipids;
b = imageplacement(a, width, height, handles.amt_lipids, handles.range_lipids);
handles.new_img_lipids = b(:,:,1);
handles.new_g_lipids = b(:,:,2);

handles=show_result(handles);
guidata(hObject, handles);

% --- Executes on button press in button_run_dirt.
function button_run_dirt_Callback(hObject, eventdata, handles)
% hObject    handle to button_run_dirt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

width = handles.width;
height = handles.height;
handles.old_img_dirt = handles.new_img_dirt;
handles.old_g_dirt = handles.new_g_dirt;

a = zeros(size(handles.img_dirt, 1), size(handles.img_dirt, 2), 2);
a(:,:,1) = handles.img_dirt;
a(:,:,2) = handles.g_dirt;
b = imageplacement_guided(a, width, height, handles.amt_dirt, handles.range_dirt);
handles.new_img_dirt = b(:,:,1);
handles.new_g_dirt = b(:,:,2);

handles=show_result(handles);
guidata(hObject, handles);

% --- Executes on button press in button_run_dust.
function button_run_dust_Callback(hObject, eventdata, handles)
% hObject    handle to button_run_dust (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

tilesize = handles.tilesize;
width = handles.width;
height = handles.height;
overlap = handles.overlap;
err = handles.err;

n_row = ceil((height-overlap)/(tilesize-overlap));
n_col = ceil((width-overlap)/(tilesize-overlap));

img = zeros(size(handles.img_dust,1), size(handles.img_dust,2), 2);
img(:,:,1) = handles.img_dust;
img(:,:,2) = handles.g_dust;
w0 = size(img,2);
h0 = size(img,1);
w1 = floor(w0/tilesize)*tilesize;
h1 = floor(h0/tilesize)*tilesize;
img = img(1:h1, 1:w1, :);

disp('Image quilting ...');
new_img = imagequilt4(img, tilesize, n_row, n_col, overlap, err);

handles.old_img_dust = handles.new_img_dust;
handles.old_g_dust = handles.new_g_dust;

handles.new_img_dust = new_img(1:height, 1:width, 1);
handles.new_g_dust = new_img(1:height, 1:width, 2);

handles=show_result(handles);

guidata(hObject, handles);


% --- Executes on button press in checkbox_lipids.
function checkbox_lipids_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_lipids (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_lipids

handles.visible_lipids = get(hObject, 'Value');
handles=show_result(handles);
guidata(hObject, handles);

% --- Executes on button press in checkbox_dirt.
function checkbox_dirt_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_dirt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_dirt

handles.visible_dirt = get(hObject, 'Value');
handles=show_result(handles);
guidata(hObject, handles);

% --- Executes on button press in checkbox_dust.
function checkbox_dust_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_dust (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_dust

handles.visible_dust = get(hObject, 'Value');
handles=show_result(handles);
guidata(hObject, handles);


% --- Executes on button press in button_lipids_add.
function button_lipids_add_Callback(hObject, eventdata, handles)
% hObject    handle to button_lipids_add (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

width = handles.width;
height = handles.height;
handles.old_img_lipids = handles.new_img_lipids;
handles.old_g_lipids = handles.new_g_lipids;

a = zeros(size(handles.img_lipids, 1), size(handles.img_lipids, 2), 2);
a(:,:,1) = handles.img_lipids;
a(:,:,2) = handles.g_lipids;
b = imageplacement(a, width, height, handles.amt_lipids, handles.range_lipids);
handles.new_img_lipids = handles.new_img_lipids+b(:,:,1);
handles.new_g_lipids = 0.5*handles.new_img_lipids+0.5*b(:,:,2);

handles=show_result(handles);
guidata(hObject, handles);

% --- Executes on button press in button_dirt_add.
function button_dirt_add_Callback(hObject, eventdata, handles)
% hObject    handle to button_dirt_add (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

width = handles.width;
height = handles.height;
handles.old_img_dirt = handles.new_img_dirt;
handles.old_g_dirt = handles.new_g_dirt;

a = zeros(size(handles.img_dirt, 1), size(handles.img_dirt, 2), 2);
a(:,:,1) = handles.img_dirt;
a(:,:,2) = handles.g_dirt;
b = imageplacement_guided(a, width, height, handles.amt_dirt, handles.range_dirt);
handles.new_img_dirt = handles.new_img_dirt+b(:,:,1);
handles.new_g_dirt = 0.5*handles.new_g_dirt+0.5*b(:,:,2);

handles=show_result(handles);
guidata(hObject, handles);

% --- Executes on button press in button_dust_add.
function button_dust_add_Callback(hObject, eventdata, handles)
% hObject    handle to button_dust_add (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

tilesize = handles.tilesize;
width = handles.width;
height = handles.height;
overlap = handles.overlap;
err = handles.err;

n_row = ceil((height-overlap)/(tilesize-overlap));
n_col = ceil((width-overlap)/(tilesize-overlap));

img = zeros(size(handles.img_dust,1), size(handles.img_dust,2), 2);
img(:,:,1) = handles.img_dust;
img(:,:,2) = handles.g_dust;
w0 = size(img,2);
h0 = size(img,1);
w1 = floor(w0/tilesize)*tilesize;
h1 = floor(h0/tilesize)*tilesize;
img = img(1:h1, 1:w1, :);

disp('Image quilting ...');
new_img = imagequilt4(img, tilesize, n_row, n_col, overlap, err);

handles.old_img_dust = handles.new_img_dust;
handles.old_g_dust = handles.new_g_dust;

handles.new_img_dust = handles.new_img_dust + new_img(1:height, 1:width, 1);
handles.new_g_dust = 0.5*handles.new_g_dust + 0.5*new_img(1:height, 1:width, 2);

handles=show_result(handles);

guidata(hObject, handles);

% --- Executes on slider movement.
function slider_lipids_range_Callback(hObject, eventdata, handles)
% hObject    handle to slider_lipids_range (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.range_lipids = get(hObject, 'Value');
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function slider_lipids_range_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_lipids_range (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on slider movement.
function slider_dirt_range_Callback(hObject, eventdata, handles)
% hObject    handle to slider_dirt_range (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

handles.range_dirt = get(hObject, 'Value');
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function slider_dirt_range_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider_dirt_range (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


% --- Executes on button press in checkbox_visible_tau.
function checkbox_visible_tau_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_visible_tau (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_visible_tau

handles.visible_tau = get(hObject, 'Value');
handles=show_result(handles);
guidata(hObject, handles);

% --- Executes on button press in checkbox_visible_g.
function checkbox_visible_g_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_visible_g (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_visible_g

handles.visible_g = get(hObject, 'Value');
handles=show_result(handles);
guidata(hObject, handles);


function edit_lipids_weight_Callback(hObject, eventdata, handles)
% hObject    handle to edit_lipids_weight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_lipids_weight as text
%        str2double(get(hObject,'String')) returns contents of edit_lipids_weight as a double

handles.weight_lipids = str2double(get(hObject, 'String'));
handles=show_result(handles);
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_lipids_weight_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_lipids_weight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_dirt_weight_Callback(hObject, eventdata, handles)
% hObject    handle to edit_dirt_weight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_dirt_weight as text
%        str2double(get(hObject,'String')) returns contents of edit_dirt_weight as a double

handles.weight_dirt = str2double(get(hObject, 'String'));
handles=show_result(handles);
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function edit_dirt_weight_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_dirt_weight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_dust_weight_Callback(hObject, eventdata, handles)
% hObject    handle to edit_dust_weight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_dust_weight as text
%        str2double(get(hObject,'String')) returns contents of edit_dust_weight as a double
handles.weight_dust = str2double(get(hObject, 'String'));
handles=show_result(handles);
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit_dust_weight_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_dust_weight (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in button_undo_lipids.
function button_undo_lipids_Callback(hObject, eventdata, handles)
% hObject    handle to button_undo_lipids (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.new_img_lipids = handles.old_img_lipids;
handles.new_g_lipids = handles.old_g_lipids;
handles=show_result(handles);
guidata(hObject, handles);

% --- Executes on button press in button_undo_dirt.
function button_undo_dirt_Callback(hObject, eventdata, handles)
% hObject    handle to button_undo_dirt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.new_img_dirt = handles.old_img_dirt;
handles.new_g_dirt = handles.old_g_dirt;
handles=show_result(handles);
guidata(hObject, handles);

% --- Executes on button press in button_undo_dust.
function button_undo_dust_Callback(hObject, eventdata, handles)
% hObject    handle to button_undo_dust (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.new_img_dust = handles.old_img_dust;
handles.new_g_dust = handles.old_g_dust;
handles=show_result(handles);
guidata(hObject, handles);

% --- Executes on button press in button_close.
function button_close_Callback(hObject, eventdata, handles)
% hObject    handle to button_close (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close;
